package italo.pacman.algorithm;


public abstract class AbstractAlgorithm implements Algorithm {

	protected Thread2 thread;
	protected String name;
	
	protected AbstractAlgorithm(String name) {
		this.name = name;		
	}
	
	public String getName() {
		return name;
	}
	
	public void run() {
		this.newThread();
		thread.run();
	}
	
	public void start() {
		this.newThread();
		thread.start();
	}
	
	public void join() {
		try {
			thread.join();
		} catch (InterruptedException e) {
			
		}
	}
	
	public void notify2() {
		synchronized(this) {
			notify();
		}
	}

	public void wait2() {
		try {
			synchronized(this) {
				wait();
			}
		} catch (InterruptedException e) {
			
		}
	}
	
	private void newThread() {
		if(thread != null)
			this.join();
		thread = new Thread2(name, this);
	}
		
}
