package italo.pacman.algorithm.time;

import italo.pacman.algorithm.AbstractAlgorithm;

public class TimeAlgorithm extends AbstractAlgorithm {

	public final static int DELAY = 1;
	public final static int COUNT_DEFAULT = 1;
	public final static String THREAD_NAME_DEFAULT = "THREAD (TIME)";
		
	private TimeConditions conditions;
	private int time;
	private int count;
	
	public TimeAlgorithm(String name, TimeConditions conditions, int time) {
		super(name);
		this.conditions = conditions;
		this.time = time;
		this.count = COUNT_DEFAULT;
	}
	
	public TimeAlgorithm(TimeConditions conditions, int time) {
		this(THREAD_NAME_DEFAULT, conditions, time);
	}

	public void begined() { 
		this.count = COUNT_DEFAULT;
		conditions.timeBegined();
	}
	
	public void ended() {		
		conditions.timeEnded();
	}
		
	public boolean pauseCondition() {
		return conditions.pauseCondition();
	}
	
	public boolean executionCondition() {
		return conditions.executionCondition() && count <= time;
	}
	
	public boolean pausable() {
		return conditions.pausable();
	}
	
	public void execute() {
		try {
			Thread.sleep(DELAY);
			count++;
		} catch (InterruptedException e) {
			
		}
	}	
		
}
