package italo.pacman.constants;

import italo.pacman.logic.game.direction.Direction;
import italo.pacman.logic.game.direction.DownDirection;
import italo.pacman.logic.game.direction.LeftDirection;
import italo.pacman.logic.game.direction.RightDirection;
import italo.pacman.logic.game.direction.UpDirection;

public interface DirectionConstants {
	
	public final static int VALOR_INCREMENTO = 1;

	public final static Direction RIGHT_DIRECTION = new RightDirection();
	public final static Direction LEFT_DIRECTION = new LeftDirection();
	public final static Direction DOWN_DIRECTION = new DownDirection();
	public final static Direction UP_DIRECTION = new UpDirection();
	
	public final static String STRING_RIGHT_DIRECTION = "frente";
	public final static String STRING_DOWN_DIRECTION = "baixo";
	public final static String STRING_LEFT_DIRECTION = "traz";
	public final static String STRING_UP_DIRECTION = "cima"; 

	public final static String[] STRING_DIRECTIONS = {
		STRING_RIGHT_DIRECTION, 
		STRING_DOWN_DIRECTION, 
		STRING_LEFT_DIRECTION, 
		STRING_UP_DIRECTION
	};
	
	public final static Direction[] DIRECTIONS = {
		LEFT_DIRECTION, 
		DOWN_DIRECTION, 
		RIGHT_DIRECTION, 
		UP_DIRECTION		
	};
	
	public final static int[][] DIRECTIONS_XY_CELL = {
		{-1,  0}, {0 ,  1}, {1 ,  0}, {0 , -1}
	};
	
	public final static int[][] DIRECTIONS_XY_WALL = {
		{0,  0}, {0 ,  1}, {1 ,  0}, {0 , 0}
	};

}
