package italo.pacman.controller;

import italo.pacman.constants.AudioConstants;
import italo.pacman.logic.SistemaFacade;
import italo.pacman.multimidia.MultimidiaFacade;
import italo.pacman.trick.Trick;
import italo.pacman.trick.TrickListener;

public class HandleCrossWallTrick implements TrickListener {
	
	public final static int TEMPO_SLEEP_AUDIO = 0;
	
	public void trickFinish(Trick trick) {
		boolean crossWall = (trick.getStatus() == Trick.TRICK_ACTIVE);
		String nameAudio = crossWall ? AudioConstants.ATRAVESSAR_PAREDES : AudioConstants.NAO_ATRAVESSAR_PAREDES;
		MultimidiaFacade.getInstance().executeAudio(nameAudio);
		SistemaFacade.getInstance().getCurrentGame().setCrossWall(crossWall);
	}
	
}
