package italo.pacman.controller;

import italo.pacman.gui.GUIFacade;
import italo.pacman.logic.encerramento.Encerramento;
import italo.pacman.logic.encerramento.event.EncerramentoListener;
import italo.pacman.logic.game.bound.Bound;
import italo.pacman.multimidia.MultimidiaFacade;

public class HandleEncerramento implements EncerramentoListener {

	public void init(Encerramento encerramento) {
		encerramento.init( GUIFacade.getInstance().getEncerramentoPicture() );
		encerramento.setImage( MultimidiaFacade.getInstance().getImagemEncerramento("1") ); 							
		GUIFacade.getInstance().setCurrentPicture( 
				GUIFacade.getInstance().getEncerramentoPicture() );
		GUIFacade.getInstance().repaint();
	}

	public void initialize(Encerramento encerramento) {
		int x = 0;
		int y = 0;
		int width = GUIFacade.getInstance().getPersonalPanel().getWidth();
		int height = GUIFacade.getInstance().getPersonalPanel().getHeight();
		encerramento.initialize( new Bound(x, y, width, height) );
	}

}
