package italo.pacman.controller;

import italo.pacman.gui.GUIFacade;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.event.FaseListener;
import italo.pacman.logic.game.event.MonsterListener;
import italo.pacman.logic.game.event.PacmanListener;
import italo.pacman.logic.game.event.PersonageListener;
import italo.pacman.multimidia.MultimidiaFacade;

public class HandleFase implements FaseListener {
	
	private PersonageListener handlePersonage = new HandlePersonage();
	private MonsterListener handleMonster = new HandleMonster();
	private PacmanListener handlePacman = new HandlePacman();	
	
	public void initialize(Fase fase) {
		
	}
	
	public void init(Fase fase) {
		MultimidiaFacade.getInstance().executeAudioFase(String.valueOf(fase.getNumber()));		
		fase.init( GUIFacade.getInstance().getGamePicture().getTrayPicture() );		
	}

	public void reinit(Fase fase) {
		
	}
	
	public void finish(Fase fase) {
		
	}
	
	public void begin(Fase fase) {		
		fase.getTray().getPacman().setPersonageListener(handlePersonage);
		fase.getTray().getPacman().setPacmanListener(handlePacman);
		for(Monster monstrinho:fase.getTray().getMonsters()) {
			monstrinho.setPersonageListener(handlePersonage);
			monstrinho.setMonsterListener(handleMonster);
		}			
	}
	
	public void end(Fase fase) {
		fase.getTray().getPacman().removePersonageListener();
		fase.getTray().getPacman().removePacmanListener();		
		for(Monster monstrinho:fase.getTray().getMonsters()) {
			monstrinho.removePersonageListener();
			monstrinho.removeMonsterListener();
		}		
	}
	

}
