package italo.pacman.controller;

import italo.pacman.constants.DirectionConstants;
import italo.pacman.constants.MessageConstants;
import italo.pacman.gui.input.event.InputGameListener;
import italo.pacman.logic.SistemaFacade;
import italo.pacman.logic.game.Game;
import italo.pacman.logic.game.Pacman;
import italo.pacman.trick.Trick;
import italo.pacman.trick.TrickController;

import java.util.Collection;

public class HandleGameInput implements InputGameListener, MessageConstants {
			
	public void downPressed() {
		Pacman pacman = SistemaFacade.getInstance().getCurrentPacman(); 
		pacman.setNewDirection(DirectionConstants.DOWN_DIRECTION);
	}

	public void upPressed() {
		Pacman pacman = SistemaFacade.getInstance().getCurrentPacman(); 
		pacman.setNewDirection(DirectionConstants.UP_DIRECTION);
	}

	public void rightPressed() {
		Pacman pacman = SistemaFacade.getInstance().getCurrentPacman(); 
		pacman.setNewDirection(DirectionConstants.RIGHT_DIRECTION);
	}

	public void leftPressed() {
		Pacman pacman = SistemaFacade.getInstance().getCurrentPacman(); 
		pacman.setNewDirection(DirectionConstants.LEFT_DIRECTION);
	}

	public void altReleased() {
		
	}

	public void altPressed() {
		
	}

	public void enterPressed() {
		Game game = SistemaFacade.getInstance().getCurrentGame();
		game.gamePause();		
	}

	public void keyPressed(char key) {		
		Game game = SistemaFacade.getInstance().getCurrentGame();
		if(game.isPause()) {			
			Collection<Trick> tricks = TrickController.getInstance().getGameTricks(); 
			for(Trick t:tricks)
				t.keyPressed(key);
		}
	}

}
