package italo.pacman.controller;

import italo.pacman.constants.PersonageConstants;
import italo.pacman.constants.StateConstants;
import italo.pacman.controller.algorithm.TimeStateAlgorithm;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.event.MonsterListener;
import italo.pacman.logic.game.state.State;

public class HandleMonster implements MonsterListener {
	
	public void enterInHouse(Monster monster) {
		
	}

	public void changeState(Monster monster, State state) {
		if(state != StateConstants.STRONG_STATE) {
			monster.setRouteVisible( false );
			if(state == StateConstants.WEAK_STATE) {
				Fase fase = monster.getTray().getFase();
				TimeStateAlgorithm algoritmo = new TimeStateAlgorithm(
						monster, fase, PersonageConstants.TEMPO_RECUPERACAO_MONSTRINHO);
				algoritmo.start();
			}
		}
	}

	public void catchPacman(Monster monster, Pacman pacman) {
		monster.getTray().getFase().getGame().perdeu();
	}

	public void exitOfHouse(Monster monster) {
		monster.setState(StateConstants.STRONG_STATE);
	}

}
