package italo.pacman.controller;

import italo.pacman.constants.AudioConstants;
import italo.pacman.constants.GameConstants;
import italo.pacman.constants.StateConstants;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Score;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.event.PacmanListener;
import italo.pacman.multimidia.MultimidiaFacade;

import java.util.List;

public class HandlePacman implements PacmanListener {

	public final static int FATOR_AUDIO_COMEU = 3;
	
	public void eatBoll(Pacman pacman) {		
		Fase fase = pacman.getTray().getFase();
		Score score = fase.getGame().getScore();
		score.setScoreValue( score.getScoreValue() + GameConstants.EAT_BOLL_SCORE );		
		fase.setBollsQuantity(fase.getBollsQuantity()-1);		
		if(fase.getBollsQuantity() <= 0) 
			fase.getGame().passouDeFase();	
		if(fase.getBollsQuantity() % FATOR_AUDIO_COMEU == 0)
			MultimidiaFacade.getInstance().executeAudio(AudioConstants.COMEU);				
	}

	public void eatBigBoll(Pacman pacman) {
		Tray tray = pacman.getTray();
		List<Monster> mosnters = tray.getMonsters();		
		for(Monster monster:mosnters) {
			if(monster.getState().equals(StateConstants.STRONG_STATE)) 
				monster.setState(StateConstants.WEAK_STATE);
		}
		Score score = tray.getFase().getGame().getScore(); 
		score.setScoreValue( score.getScoreValue() + GameConstants.EAT_BIG_BOLL_SCORE );
		MultimidiaFacade.getInstance().executeAudio(AudioConstants.COMEUBG);
	}

	public void eatMonster(Pacman pacman, Monster monstrinho) {
		monstrinho.setState(StateConstants.MUCH_WEAK_STATE);
		Score score = pacman.getTray().getFase().getGame().getScore(); 
		score.setScoreValue( score.getScoreValue() + GameConstants.EAT_MONSTER_SCORE );
		MultimidiaFacade.getInstance().executeAudio(AudioConstants.OOPS);
	}

}
