package italo.pacman.controller;

import java.awt.Image;

import italo.pacman.algorithm.pause.event.PauseListener;
import italo.pacman.constants.ImageConstants;
import italo.pacman.constants.MessageConstants;
import italo.pacman.logic.SistemaFacade;
import italo.pacman.logic.game.Game;
import italo.pacman.multimidia.MultimidiaFacade;
import italo.pacman.multimidia.message.MessageController;

public class HandlePauseGame implements PauseListener {

	public final static int SHOW_MESSAGE_TIME = 0;
	public final static boolean HIDE_MESSAGE = false;
	public final static boolean JOIN_MESSAGE = false;
	
	public void continueGame() {
		MessageController.getInstance().apagarMensagem();	
	}

	public void pauseGame() {
		Game game = SistemaFacade.getInstance().getCurrentGame();
		Image image = MultimidiaFacade.getInstance().getImagemMensagem(ImageConstants.MENSAGEM_PAUSE);
		MessageController.getInstance().desenharMensagem(image, game, 
				MessageConstants.PAUSE_MESSAGE_WIDTH_FACTOR, MessageConstants.PAUSE_MESSAGE_HEIGHT_FACTOR, 
				SHOW_MESSAGE_TIME, HIDE_MESSAGE, JOIN_MESSAGE);	
	}

}
