package italo.pacman.controller.algorithm;

import italo.pacman.algorithm.AbstractAlgorithm;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Game;

public class GameAlgorithm extends AbstractAlgorithm {
	
	private Game game;
	
	public GameAlgorithm(Game game) {
		super("THREAD (GAME)");
		this.game = game;
	}
		
	public boolean pauseCondition() {
		return false;
	}
		
	public boolean pausable() {
		return false;
	}
	
	public void begined() {		
		game.begin();				
	}

	public void ended() {
		game.end();
	}

	public boolean executionCondition() {
		return !game.finalized();
	}
				
	public void execute() {
		Fase fase = game.getCurrentFase();	
		FaseAlgorithm faseAlgorithm = new FaseAlgorithm(game, fase);
		faseAlgorithm.init();
		faseAlgorithm.run();
		
		if(!game.finalized()) {
			if(game.getCurrentFase().equals(fase)) { 
				if(fase.getBollsQuantity() <= 0) {
					game.nextFase();
					game.getCurrentFase().init();
				} else {
					fase.reinit();
				}
			} else {
				game.getCurrentFase().init();
			}
		}
		
	}
	
}
