package italo.pacman.controller.algorithm;

import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Game;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.difficulty.Difficulty;
import italo.pacman.logic.game.state.State;


public class MonsterAlgorithm extends PersonageAlgorithm {		
		
	public MonsterAlgorithm(Game game, Monster monster, Fase fase) {
		super("THREAD (MONSTER"+monster.getId()+")", game, monster, fase); 
	}
			
	public void begined() {
		super.begined();
	}
	
	public void ended() {
		super.ended();
	}
	
	public void execute() {
		repaint();		
		mover();						
	}
	
	public void mover() {
		Difficulty dificuldade = fase.getGame().getDifficulty();
		Tray tabuleiro = fase.getTray();
		Monster monstrinho = (Monster)personagem;
		State estado = monstrinho.getState();
		boolean moveu = estado.move(monstrinho, tabuleiro, dificuldade);
		if(moveu)
			super.mover();
	}
		
	public void repaint() {		
		Monster monstrinho = (Monster)personagem;
		State estado = monstrinho.getState();
		if(super.iteration++ % estado.getSpeed(monstrinho) == 0)
			monstrinho.repaint();		
	}

	public Monster getMonstrinho() {
		return (Monster) super.personagem;
	}
		
}
