package italo.pacman.controller.algorithm;

import italo.pacman.constants.MotionConstants;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Game;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Personage;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.motion.Motion;


public class PacmanAlgorithm extends PersonageAlgorithm {
	
	
	public PacmanAlgorithm(Game game, Personage personagem, Fase fase) {
		super("THREAD (PACMAN)", game, personagem, fase);
	}	
			
	public void begined() {
		super.begined();
	}
	
	public void ended() {
		super.ended();
	}
	
	public void execute() {
		repaint();	
		mover();
		comer();			
	}
			
	public void mover() {		
		Tray tabuleiro = fase.getTray();
		Motion movimento = MotionConstants.NORMAL_MOTION;
		boolean moveu = movimento.move(personagem, tabuleiro);
		if(moveu)
			super.mover();
	}
	
	public void comer() {
		Pacman pacman = (Pacman)personagem;
		Tray tabuleiro = fase.getTray();
		int xB = tabuleiro.getXBoll(pacman);
		int yB = tabuleiro.getYBoll(pacman);
		if(tabuleiro.hasBoll(xB, yB)) {
			tabuleiro.eat(xB, yB);
			pacman.eatBoll(); 			
			if(tabuleiro.isBigBoll(xB, yB))
				pacman.eatBigBoll();				
		}
	}
	
	private void repaint() {
		if(super.iteration++ % personagem.getSpeed() == 0) 
			personagem.repaint();		
	}
			
}
