package italo.pacman.controller.algorithm;

import italo.pacman.algorithm.AbstractAlgorithm;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Game;
import italo.pacman.logic.game.Personage;

abstract class PersonageAlgorithm extends AbstractAlgorithm {

	protected Game game;
	protected Personage personagem;
	protected Fase fase;
	protected int iteration;
	
	protected PersonageAlgorithm(String name, Game game, Personage personagem, Fase fase) {
		super(name);
		this.game = game;
		this.personagem = personagem;
		this.fase = fase;
		this.iteration = 0;
	}

	public void begined() {	
		personagem.begin();
	}
	
	public void ended() {
		personagem.end();	
	}
	
	public boolean executionCondition() {
		return !fase.finalized();
	}
	
	public boolean pauseCondition() {		
		return game.isPause();
	}
	
	public boolean pausable() {
		return true;
	}
	
	protected void mover() {
		personagem.move();
	}
		
}
