package italo.pacman.controller.algorithm;

import italo.pacman.algorithm.AbstractAlgorithm;
import italo.pacman.constants.PictureConstants;
import italo.pacman.gui.GUIFacade;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Game;
import italo.pacman.utilities.Utilities;


public class PictureAlgorithm extends AbstractAlgorithm {
		
	private Game game;
	private Fase fase;
	
	public PictureAlgorithm(Game game, Fase fase) {		
		super("THREAD (PICTURE)");
		this.game = game;
		this.fase = fase;
	}

	public boolean pauseCondition() {
		return game.isPause();
	}
	
	public boolean pausable() {
		return true;
	}
			
	public void begined() {
		
	}
	
	public void ended() {
		
	}
	
	public boolean executionCondition() {
		return !fase.finalized();
	}

	public void execute() {			
		if(!fase.finalized())
			GUIFacade.getInstance().repaint();
		Utilities.sleep(PictureConstants.PICTURE_REPAINT_FACTOR);	
	}
			
}

	