package italo.pacman.controller.algorithm;
import italo.pacman.algorithm.AbstractAlgorithm;
import italo.pacman.logic.Sistema;


public class SistemaAlgorithm extends AbstractAlgorithm {
		
	private Sistema sistema;
	
	public SistemaAlgorithm(String name, Sistema sistema) {
		super(name);
		this.sistema = sistema;
	}
	
	public void begined() {			
		sistema.begin();
	}

	public void ended() {		
		sistema.end();		
	}
	
	public void execute() {
		sistema.getGame().init();
		sistema.getGame().play();
		sistema.getGame().finish();
	}
	
	public boolean executionCondition() {
		return !sistema.finalized(); 
	}

	public boolean pausable() {
		return false;
	}
	
	public boolean pauseCondition() {
		return false;
	}
		
}
