package italo.pacman.gui;

import italo.pacman.constants.GUIConstants;
import italo.pacman.gui.menu.MenuAction;
import italo.pacman.gui.menu.MenuSource;
import italo.pacman.gui.menu.event.MenuActionListener;

import java.awt.BorderLayout;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

public class ContainerPanel extends JPanel implements MenuSource, GUIConstants {

	private static final long serialVersionUID = 1L;
	
	private PersonalPanel personalPanel;
	
	private JMenuBar menuMB;
	
	private JMenu gameM;
	
	private JMenuItem reinitMI;
	private JMenuItem exitMI;
			
	private MenuActionListener listener;
	
	private MenuAction menuAction = new MenuAction(this);
	
	public ContainerPanel(ContainerModel containerModel) {				
		super.setLayout(new BorderLayout());
		super.add("North",  getMenuBar());
		super.add("Center", getPainelPersonalizado());		
	}
	
	
	public JMenuBar getMenuBar() {
		if(menuMB == null) {
			menuMB = new JMenuBar();
			menuMB.add( getGameMenu() );
		}
		return menuMB;
	}
	
	public JMenu getGameMenu() {
		if(gameM == null) {
			gameM = new JMenu(LABEL_GAME_MENU);
			gameM.add( getReinitMenuItem() );
			gameM.add( getExitMenuItem() ); 
		}
		return gameM;
	}
	
	public JMenuItem getReinitMenuItem() {
		if(reinitMI == null) {
			reinitMI = new JMenuItem(LABEL_REINIT_MENU_ITEM);
			reinitMI.addActionListener(menuAction);
		}
		return reinitMI;
	}
	
	public JMenuItem getExitMenuItem() {
		if(exitMI == null) {
			exitMI = new JMenuItem(LABEL_EXIT_MENU_ITEM);
			exitMI.addActionListener(menuAction);
		}
		return exitMI;
	}
	
	
	public PersonalPanel getPainelPersonalizado() {
		if(personalPanel == null) {
			personalPanel = new PersonalPanel();
			personalPanel.setBackground(COR_FUNDO_PAINEL_PERSONALIZADO);
		}
		return personalPanel;
	}
	
	public void setMenuActionListener(MenuActionListener listener) {
		this.listener = listener;
	}
	
	public void removeMenuActionListener() {
		this.listener = null;
	}
	
	public MenuActionListener getMenuActionListener() {
		return listener;
	}

}
