package italo.pacman.gui;

import italo.pacman.gui.input.Input;
import italo.pacman.picture.Picture;
import italo.pacman.picture.abertura.AberturaPicture;
import italo.pacman.picture.encerramento.EncerramentoPicture;
import italo.pacman.picture.game.GamePicture;


public class GUIFacade {

	private static GUIFacade singleton = null;
	
	private ContainerModel container;
	
	private AberturaPicture aberturaPicture = new AberturaPicture();	
	private GamePicture gamePicture = new GamePicture();
	private EncerramentoPicture encerramentoPicture = new EncerramentoPicture();
		
	private GUIFacade() {}
	
	public static GUIFacade getInstance() {
		if(singleton == null) {
			synchronized(GUIFacade.class) {
				singleton = new GUIFacade();
			}
		}
		return singleton;
	}
	
	public void initialize(ContainerModel container) {
		this.container = container;
	}
			
	public Input getInput() {
		return container.getInput();
	}
	
	public void setVisible(boolean b) {
		container.getContainer2().setVisible(b);
	}
			
	public Picture getCurrentPicture() {
		return container.getPersonalPanel().getPicture();
	}
	
	public void setCurrentPicture(Picture picture) {
		container.getPersonalPanel().setPicture(picture);                
	}

	public void repaint() {
		container.getPersonalPanel().repaint();
	}
	
	public PersonalPanel getPersonalPanel() {
		return container.getPersonalPanel();
	}

	public AberturaPicture getAberturaPicture() {
		return aberturaPicture;
	}

	public GamePicture getGamePicture() {
		return gamePicture;
	}
	
	public ContainerModel getContainerModel() {
		return container;
	}
	
	public void setContainerModel(ContainerModel container) {
		this.container = container;
	}
	
	public EncerramentoPicture getEncerramentoPicture() {
		return encerramentoPicture;
	}
	
}
