package italo.pacman.gui.input;


import italo.pacman.gui.input.event.InputContainerListener;

import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;


class InputContainerAction implements KeyListener, ComponentListener {
	
	private boolean altPressed = false;
		
	private InputKey input;
	
	public InputContainerAction(InputKey input) {
		this.input = input;
	}
	
	public void iniciar() {
		altPressed = false;
	}
	
	public void keyPressed(KeyEvent e){
		keyPressed(e.getKeyChar());
		if(e.getKeyCode() == KeyEvent.VK_ENTER) {
			if(altPressed) {
				altEnterPressed();
			}
		} else if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
			escapePressed();			
		} else if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressed = true;
		}
	}
	
	public void keyReleased(KeyEvent e){
		if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressed = false;
		}
	}

	public void keyTyped(KeyEvent e) {}
	
	public void componentHidden(ComponentEvent e) {}

	public void componentShown(ComponentEvent e) {}
	
	public void componentMoved(ComponentEvent e) {}
	
	public void componentResized(ComponentEvent e) {
		containerResized();
	}

	public void keyPressed(char key) {
		InputContainerListener listener = input.getInputContainerListener();
		if(listener != null)
			listener.keyPressed(key);
	}
	
	public void altEnterPressed() {
		InputContainerListener listener = input.getInputContainerListener();
		if(listener != null)
			listener.altEnterPressed();
	}
	
	public void escapePressed() {
		InputContainerListener listener = input.getInputContainerListener();
		if(listener != null)
			listener.escapePressed();
	}
	
	public void containerResized() {
		InputContainerListener listener = input.getInputContainerListener();
		if(listener != null)
			listener.containerResized();
	}
		
}
