package italo.pacman.gui.input;


import italo.pacman.gui.input.event.InputGameListener;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;


class InputGameAction implements KeyListener {
	
	private InputKey entrada;
	
	public InputGameAction(InputKey entrada) {
		this.entrada = entrada;
	}
	
	public void keyPressed(KeyEvent e){		
		teclaPressionada(e.getKeyChar());
		if(e.getKeyCode() == KeyEvent.VK_LEFT) {
			paraTrazPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_RIGHT) {
			paraFrentePressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_DOWN) {
			paraBaixoPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_UP) {
			paraCimaPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ENTER) {
			enterPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado();
		}		
	}
	
	public void keyReleased(KeyEvent e){
		if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altLiberado();
		}
	}

	public void keyTyped(KeyEvent e) {
		
	}
	
	public void teclaPressionada(char tecla) {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.keyPressed(tecla);
	}
	
	public void paraFrentePressionado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.rightPressed();
	}
	
	public void paraTrazPressionado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.leftPressed();
	}
	
	public void paraBaixoPressionado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.downPressed();
	}
	
	public void paraCimaPressionado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.upPressed();
	}
	
	public void altPressionado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.altPressed();
	}
	
	public void altLiberado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.altReleased();
	}
	
	public void enterPressionado() {
		InputGameListener listener = entrada.getInputGameListener();
		if(listener != null)
			listener.enterPressed();
	}
	
	
}
