package italo.pacman.gui.input;

import italo.pacman.gui.input.event.InputContainerListener;
import italo.pacman.gui.input.event.InputGameListener;
import italo.pacman.gui.menu.event.MenuActionListener;

import java.awt.Container;


public class InputKey implements Input{
	
	private InputContainerAction inputContainerAction = new InputContainerAction(this); 	
	private InputGameAction inputGameAction = new InputGameAction(this);
	
	private InputContainerListener inputContainerListener;
	private InputGameListener inputGameListener;
	private MenuActionListener inputMenuListener; 
	
	public InputKey(Container container) {
		container.addComponentListener(inputContainerAction);
		container.addKeyListener(inputContainerAction);
		container.addKeyListener(inputGameAction);
	}

	public void setInputContainerListener(InputContainerListener listener) {
		this.inputContainerListener = listener;
	}
			
	public void setInputGameListener(InputGameListener listener) {
		this.inputGameListener = listener;
	}
	
	public void setInputMenuListener(MenuActionListener listener) {
		this.inputMenuListener = listener;
	}
	
	public void removeInputContainerListener() {
		this.inputContainerListener = null;
	}
	
	public void removeInputGameListener() {
		this.inputGameListener = null;
	}
	
	public void removeInputMenuListener() {
		this.inputMenuListener = null;
	}
	
	public InputContainerListener getInputContainerListener() {
		return inputContainerListener;
	}

	public InputGameListener getInputGameListener() {
		return inputGameListener;
	}

	public MenuActionListener getInputMenuListener() {
		return inputMenuListener;
	}
		
	
}
 