package italo.pacman.gui.menu;


import italo.pacman.gui.menu.event.MenuActionListener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class MenuAction implements ActionListener {
		
	private MenuSource source;
	
	public MenuAction(MenuSource source) {
		this.source = source;
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == source.getReinitMenuItem()) {
			this.reinit();
		} else if(e.getSource() == source.getExitMenuItem()) {
			this.exit();
		}
	}
	
	public void reinit() {
		MenuActionListener listener = source.getMenuActionListener();
		if(listener != null)
			listener.reinit();		
	}
	
	public void exit() {
		MenuActionListener listener = source.getMenuActionListener();
		if(listener != null)
			listener.exit();	
	}
	
}

