package italo.pacman.load.game;

import italo.pacman.load.attributes.LoadGameAttributes;
import italo.pacman.load.fase.FaseLoadFacade;
import italo.pacman.load.game.properties.GameProperties;
import italo.pacman.logic.game.attributes.GameAttributes;

public class GameLoad {
	
	private GameProperties gameProperties;
	
	public GameLoad(GameProperties gameProperties) {
		this.gameProperties = gameProperties;
	}
	
	public GameLoad() {
		this(null);
	}
	
	public GameAttributes load() {
		return loadGameAttributes();
	}
	
	private GameAttributes loadGameAttributes() {	
		LoadGameAttributes gameAttributes = new LoadGameAttributes();
		gameAttributes.setLifeQuantity(gameProperties.getLifeQuantity());
		gameAttributes.setDifficulty(gameProperties.getDifficulty());
		gameAttributes.setFasesAttributes(FaseLoadFacade.loadFaseAttributes());
		return gameAttributes;
	}
	
}
