package italo.pacman.logic;

import italo.pacman.logic.abertura.Abertura;
import italo.pacman.logic.encerramento.Encerramento;
import italo.pacman.logic.event.SistemaListener;
import italo.pacman.logic.game.Game;
import italo.pacman.multimidia.MidiaLoad;

public interface Sistema {
		
	public void setSistemaListener(SistemaListener listener); 
	
	public void removeSistemaListener();
	
	public void abertura();
	
	public void encerramento();
	
	public void load();
	
	public void load(MidiaLoad midiaLoad);
	
	public void load(int nFiles);	
	
	public void loading(int percentage);
	
	public void play();
				
	public void finish();
	
	public void begin();
	
	public void end();
	
	public boolean finalized();  
			
	public Game getGame();
	
	public Abertura getAbertura();
	
	public Encerramento getEncerramento();
	
}
