package italo.pacman.logic;

import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Game;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.vo.SistemaVO;

import java.util.List;

public class SistemaFacade {

	private static SistemaFacade singleton = null;

	private Sistema sistema = new SistemaVO();
	
	private SistemaFacade() {}
	
	public static SistemaFacade getInstance() {
		if(singleton == null) {
			synchronized(SistemaFacade.class) {
				singleton = new SistemaFacade();
			}
		}
		return singleton;
	}
						
	public Game getCurrentGame() {
		return sistema.getGame();
	}
	
	public List<Fase> getCurrentFases() {
		return this.getCurrentGame().getFases();
	}
	
	public Fase getCurrentFase() {
		return this.getCurrentGame().getCurrentFase();
	}
	
	public Tray getCurrentTray() {
		return this.getCurrentFase().getTray();
	}
			
	public Pacman getCurrentPacman() {
		return (Pacman) this.getCurrentTray().getPacman(); 
	}
	
	public List<Monster> getCurrentMonsters() {
		return this.getCurrentTray().getMonsters();
	}

	public int getCurrentMonsterQuantity() {
		return getCurrentMonsters().size();
	}
		
	public Sistema getCurrentSistema() {
		return sistema;
	}
	
	
}
