package italo.pacman.logic.abertura.mediator;

import italo.pacman.adapter.picture.abertura.LogicAberturaPicture;
import italo.pacman.logic.AbstractFigureMediator;
import italo.pacman.logic.abertura.Abertura;

public class AberturaMediator extends AbstractFigureMediator {

private final static int FATOR_PORCENTAGEM = 100;
	
	private final static double FATOR_LARGURA_PROGRESS_BAR = 0.75;
	private final static double FATOR_ALTURA_PROGRESS_BAR = 0.05;
	
	private Abertura abertura;
	
	public AberturaMediator(Abertura abertura) {
		this.abertura = abertura;
	}
	
	public void init(LogicAberturaPicture picture) {
		picture.init(abertura);		
		super.setLogicPicture(picture);
		
		int x = abertura.getX();
		int y = abertura.getY();
		int width = abertura.getWidth();
		int height = abertura.getHeight();
		
		int widthPB  = x + (int) ( ( width * FATOR_LARGURA_PROGRESS_BAR ) / FATOR_PORCENTAGEM ) * FATOR_PORCENTAGEM;
		int heightPB = y + (int) ( height * FATOR_ALTURA_PROGRESS_BAR );
		int xPB = x + ( width  - widthPB  ) / 2;
		int yPB = y + ( height - heightPB ) / 2;
		
		abertura.getProgressBar().setX( xPB );
		abertura.getProgressBar().setY( yPB );
		abertura.getProgressBar().setWidth( widthPB );
		abertura.getProgressBar().setHeight( heightPB );
		abertura.getProgressBar().init( picture.getProgressBarPicture() );
	}

}
