package italo.pacman.logic.encerramento.vo;

import italo.pacman.adapter.figure.AbstractContainerFigure;
import italo.pacman.adapter.picture.encerramento.LogicEncerramentoPicture;
import italo.pacman.logic.Sistema;
import italo.pacman.logic.encerramento.Encerramento;
import italo.pacman.logic.encerramento.event.EncerramentoListener;
import italo.pacman.logic.encerramento.mediator.EncerramentoMediator;
import italo.pacman.logic.game.bound.Bound;

import java.awt.Image;

public class EncerramentoVO extends AbstractContainerFigure implements Encerramento {

	private Sistema sistema;
	private EncerramentoMediator mediator;
	private EncerramentoListener listener;
		
	public EncerramentoVO(Sistema sistema, int x, int y, int width, int height) {
		super(null, x, y, width, height);
		this.mediator = new EncerramentoMediator(this);
		this.sistema = sistema;
	}
	
	public EncerramentoVO(Sistema sistema) {
		this(sistema, 0, 0, 0, 0);
	}

	public void setEncerramentoListener(EncerramentoListener listener) {
		this.listener = listener;
	}
	
	public void removeEncerramentoListener() {
		this.listener = null;
	}
	
	public void initialize(Bound bound) {
		setX( bound.getX() );
		setY( bound.getY() );
		setWidth( bound.getWidth() );
		setHeight( bound.getHeight() );
	}
	
	public void init(LogicEncerramentoPicture picture) {
		mediator.init(picture);
	}
	
	public void initialize() {
		if(listener != null)
			listener.initialize(this);
	}
	
	public void init() {
		if(listener != null)
			listener.init(this);
	}

	public void setImage(Image image) {
		mediator.setImage(image);
	}

	public Sistema getSistema() {
		return sistema;
	}
	
}
