package italo.pacman.logic.game;

import italo.pacman.adapter.picture.game.LogicTrayPicture;
import italo.pacman.logic.game.attributes.FaseAttributes;
import italo.pacman.logic.game.event.FaseListener;
import italo.pacman.multimidia.Animation;

public interface Fase {

	public void setFaseListener(FaseListener listener);
	
	public void removeFaseListener();
	
	public void initialize(FaseAttributes faseAttributes);
	
	public void init(LogicTrayPicture picture);
	
	public void initialize();
	
	public void init();
	
	public void reinit();
	
	public void finish();
	
	public void begin();
	
	public void end();
	
	public String getNumber();

	public void setNumber(String number);
	
	public Tray getTray();

	public void setTray(Tray tray);

	public int getBollsQuantity();

	public void setBollsQuantity(int bollsQuantity);
	
	public boolean finalized();
	
	public int getInitialBollsQuantity();

	public void setInitialBollsQuantity(int initialBollsQuantity);

	public Animation getAnimation();

	public void setAnimation(Animation animation);

	public Game getGame();		
									
}
