package italo.pacman.logic.game;

import italo.pacman.adapter.figure.game.GameFigure;
import italo.pacman.adapter.picture.game.LogicGamePicture;
import italo.pacman.logic.Sistema;
import italo.pacman.logic.game.attributes.GameAttributes;
import italo.pacman.logic.game.difficulty.Difficulty;
import italo.pacman.logic.game.event.GameListener;

import java.util.List;

public interface Game extends GameFigure {
	
	public void setGameListener(GameListener listener);
	
	public void removeGameListener();
	
	public void initialize(GameAttributes gameAttributes);
	
	public void init(LogicGamePicture picture);
	
	public void initialize();
	
	public void init();
		
	public void finish();	
	
	public void begin();
	
	public void end();
	
	public void play();
	
	public Sistema getSistema();
	
	public Score getScore();
	
	public void setScore(Score score);
		
	public boolean finalized();
		
	public int getInitialLifeQuantity();		
	
	public boolean isPause();
	
	public void setPause(boolean pause);
			
	public int getLifeQuantity();

	public void setLifeQuantity(int numeroDeVidas);

	public Difficulty getDifficulty();

	public void setDifficulty(Difficulty dificuldade);

	public List<Fase> getFases();

	public boolean isCrossWall();

	public void setCrossWall(boolean crossWall);
	
	public boolean addFase(Fase fase);
	
	public boolean removeFase(Fase fase);	
	
	public Fase getCurrentFase();
		
	public boolean gotoFase(int index);
	
	public void firstFase();
	
	public void nextFase();
	
	public boolean isLastFase();
	
	public int getFasesQuantity();
	
	public int getCurrentFaseIndex();
	
	public void gamePause();
				
	public void perdeu();
	
	public void passouDeFase();
	
	public void zerou();
	
	public void gameover();
	
	public void pauseGame();
	
	public void continueGame();
						
}
