package italo.pacman.logic.game;

import italo.pacman.adapter.figure.game.MonsterFigure;
import italo.pacman.adapter.picture.game.LogicMonsterPicture;
import italo.pacman.logic.game.astar.AStarCellPosition;
import italo.pacman.logic.game.attributes.MonsterAttributes;
import italo.pacman.logic.game.event.MonsterListener;
import italo.pacman.logic.game.state.State;

import java.util.List;

public interface Monster extends Personage, MonsterFigure {
		
	public void setMonsterListener(MonsterListener listener);
	
	public void removeMonsterListener();
	
	public void catchPacman(Pacman comecome);
	
	public void enterInHouse(); 
	
	public void exitOfHouse();
	
	public void changeState(State estado);
	
	public void initialize(MonsterAttributes attributes);
	
	public void init(LogicMonsterPicture picture); 
					
	public State getState();

	public void setState(State state);
	
	public void setRouteVisible(boolean b);
	
	public void setOptimunRouteCells(List<AStarCellPosition> optimalRouteCells);
	
}
