package italo.pacman.logic.game;

import italo.pacman.adapter.figure.game.TrayFigure;
import italo.pacman.adapter.picture.game.LogicTrayPicture;
import italo.pacman.logic.game.attributes.TrayAttributes;
import italo.pacman.logic.game.bound.Bound;
import italo.pacman.logic.game.direction.Direction;
import italo.pacman.logic.game.event.TrayListener;

import java.util.List;

public interface Tray extends TrayFigure {

	public void setTrayListener(TrayListener listener);
	
	public void removeTrayListener();
		
	public void reinit();
	
	public void initialize(TrayAttributes trayAttributes);
	
	public void init(LogicTrayPicture picture);	
					
	public void resize();
	
	public void resize(Bound bound);
		
	public Fase getFase();
			
	public int horizontalCellQuantity();
	
	public int verticalCellQuantity();

	public int initialBollQuantity();
	
	public int initialBigBollQuantity();
	
	public int bollQuantity();
			
	public int bigBollQuantity();
	
	public boolean isLateralHorizontalWall(int y);
	
	public boolean isLateralVerticalWall(int x);
			
	public boolean freeHorizontalWall(int x, int y);
	
	public boolean freeVerticalWall(int x, int y);
			
	public boolean isBigBoll(int x, int y);
	
	public boolean isHorizontalDoor(int x, int y);
	
	public boolean isVerticalDoor(int x, int y);
	
	public void move(Personage personage, Direction direction);
	
	public boolean hasBoll(int x, int y);
	
	public void eat(int x, int y);
		
	public int getXBoll(Pacman pacman);
	
	public int getYBoll(Pacman pacman);
	
	public int getXCell(Personage personage);
	
	public int getYCell(Personage personage);
		
	public boolean isWithinCell(int x, int y);
	
	public boolean isHouseCell(int x, int y);
			
	public boolean[][] getInitialBolls();

	public int[][] getInitialBigBolls();
	
	public Cell getCell();

	public void setCell(Cell cell);

	public House getHouse();

	public void setHouse(House house);

	public Boll getBoll();

	public void setBoll(Boll boll);

	public BigBoll getBigBoll();

	public void setBigBoll(BigBoll bigBoll);
	
	public Message getMessage();

	public void setMessage(Message message);
		
	public Pacman getPacman();
	
	public void setPacman(Pacman pacman);
	
	public boolean addMonster(Monster monster);
	
	public boolean removeMonster(Monster monster);
	
	public List<Monster> getMonsters();
	
	public void setWidthWall(int widthWall);
	
	public void setHorizontalWalls(boolean[][] horizontalWalls);

	public void setVerticalWalls(boolean[][] verticalWalls);

	public void setDoorIndexes(int[][] doorIndexes);
	
}
