package italo.pacman.logic.game.astar.algoritmo.valueobject;

import italo.pacman.logic.game.astar.AStarCell;


public class AStarCellVO implements AStarCell {

	private AStarCellPositionVO position;
	private int g = 0;
	private int h = 0;
	private AStarCellPositionVO positionParent = null;
	
	public AStarCellVO(int x, int y) {
		this.position = new AStarCellPositionVO(x, y);
	}
	
	public AStarCellVO(AStarCellPositionVO posicao) {
		this.position = posicao;
	}
	
	public boolean posicaoIgual(AStarCellPositionVO p) {
		return (p.getX() == position.getX() && p.getY() == position.getY());
	}

	public int getF() {
		return g+h;
	}
	
	public int getX() {
		return position.getX();
	}

	public void setX(int x) {
		position.setX(x);
	}

	public int getY() {
		return position.getY();
	}

	public void setY(int y) {
		position.setY(y);
	}

	public AStarCellPositionVO getPositionParent() {
		return positionParent;
	}

	public void setPositionParent(AStarCellPositionVO parent) {
		this.positionParent = parent;
	}

	public int getG() {
		return g;
	}

	public void setG(int g) {
		this.g = g;
	}

	public int getH() {
		return h;
	}

	public void setH(int h) {
		this.h = h;
	}

	public AStarCellPositionVO getPosition() {
		return position;
	}

	public void setPosition(AStarCellPositionVO posicao) {
		this.position = posicao;
	}

	public String toString() {
		return position.toString();
	}
	
}
