package italo.pacman.logic.game.difficulty;

import italo.pacman.logic.game.Personage;
import italo.pacman.logic.game.Tray;

public abstract class AbstractDificulty implements Difficulty {

	public boolean haveCollision(Personage p1, Personage p2, Tray tabuleiro) {
		int larguraC = tabuleiro.getCell().getWidth();
		int alturaC = tabuleiro.getCell().getHeight();
		double fatorColisao = getCollisionFactor();
		double distancia = p1.distancia(p2);
		return (distancia < fatorColisao*((larguraC+alturaC)/2));
	}

	public boolean personagesNear(Personage p1, Personage p2, Tray tabuleiro) {
		int larguraC = tabuleiro.getCell().getWidth();
		int alturaC = tabuleiro.getCell().getHeight();
		double fatorProximidade = getNearnessFactor();
		double distancia = p1.distancia(p2);
		return (distancia < fatorProximidade*((larguraC+alturaC)/2));
	}
	
}
