package italo.pacman.logic.game.direction;

import italo.pacman.logic.game.Personage;
import italo.pacman.logic.game.Tray;

public class RightDirection implements Direction {
		
	public int getXNew(Personage personagem, Tray tabuleiro) {
		int xP = personagem.getX();
		int xParede = getXWall(personagem, tabuleiro);
		if(tabuleiro.isLateralVerticalWall(xParede))			
			return 0;		
		return xP+VALOR_INCREMENTO;
	}
	
	public int getYNew(Personage personagem, Tray tabuleiro) {
		return personagem.getY();
	}
	
	public int getXWall(Personage personagem, Tray tabuleiro) {
		int xP = personagem.getX();
		int larguraC = tabuleiro.getCell().getWidth();
		return (xP+larguraC)/larguraC;
	}
	
	public int getYWall(Personage personagem, Tray tabuleiro) {
		int yP = personagem.getY();
		int alturaC = tabuleiro.getCell().getHeight();
		return yP/alturaC;
	}
	
	public boolean validMotion(Personage personagem, Tray tabuleiro) {
		int yP = personagem.getY();
		int alturaC = tabuleiro.getCell().getHeight();
		return (yP % alturaC == 0);
	}
	
	public boolean isFreeWall(Personage personagem, Tray tabuleiro) {
		int xParede = getXWall(personagem, tabuleiro);
		int yParede = getYWall(personagem, tabuleiro);
		if(personagem.crossWall()) {
			if(!tabuleiro.isLateralVerticalWall(xParede))  
				return true;
		}
		return tabuleiro.freeVerticalWall(xParede, yParede);
	}
			
	public boolean isFreeWall(int xParede, int yParede, Tray tabuleiro) {
		return tabuleiro.freeVerticalWall(xParede, yParede);
	}
	
	public boolean posicaoValidaParaComer(Personage personagem, Tray tabuleiro) {
		int xP = personagem.getX();
		int meiaLC = tabuleiro.getCell().getWidth()/2; 
		return (xP % meiaLC == 0);
	}
	
	public boolean isHouseDoor(Personage personagem, Tray tabuleiro) {
		int xParede = getXWall(personagem, tabuleiro);
		int yParede = getYWall(personagem, tabuleiro);
		return tabuleiro.isVerticalDoor(xParede, yParede);
	}
	
	public Direction[] getRemainderDirection() {
		return new Direction[] {DOWN_DIRECTION, UP_DIRECTION, LEFT_DIRECTION};
	}
	
	public Direction getOppositeDirection() {
		return LEFT_DIRECTION;
	}
			
	public String getString() {
		return STRING_RIGHT_DIRECTION;
	}
	
	public String toString() {
		return getString();
	}
	
}
