package italo.pacman.logic.game.mediator;

import italo.pacman.logic.game.Fase;

import java.util.List;


public class FaseController {

	private List<Fase> fases;
	private int index;
	
	public FaseController(List<Fase> fases) {
		this.fases = fases;
		this.index = 0;
	}
	
	public FaseController() {
		this(null);
	}
	
	public boolean gotoFase(int index) {
		if(index >= 0 && index < fases.size()) {
			this.index = index;
			return true;
		}
		return false;
	}
	
	public void firstFase() {
		index = 0;
	}
	
	public void lastFase() {
		index = fases.size()-1;
	}
	
	public void nextFase() {
		index = (index+1)%fases.size();
	}
	
	public void backFase() {
		index -= (index > 0 ? 1 : -(fases.size()-1));
	}
	
	public boolean isLastFase() {
		return index == fases.size()-1;
	}

	public Fase getCurrentFase() {
		return fases.get(index);
	}
	
	public int getCurrentFaseIndex() {
		return index;
	}
	
	public int lenghtFase() {
		return fases.size();
	}
		
	public List<Fase> getFases() {
		return fases;
	}
			
}
