package italo.pacman.logic.game.mediator;

import italo.pacman.adapter.picture.game.LogicTrayPicture;
import italo.pacman.logic.game.Fase;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.attributes.FaseAttributes;
import italo.pacman.logic.game.attributes.TrayAttributes;
import italo.pacman.logic.game.vo.TrayVO;
import italo.pacman.multimidia.Animation;

public class FaseMediator {

	private int initialBollsQuantity;
	private Animation animation;
	
	private boolean endFase;
	
	private Fase fase;
	
	public FaseMediator(Fase fase) {
		this.fase = fase;
	}
	
	public void initialize(FaseAttributes faseAttributes) {
		addTray( faseAttributes.getTrayAttributes() );		
		this.initialBollsQuantity = fase.getTray().initialBollQuantity();
	}
			
	public void init(LogicTrayPicture picture) {		
		endFase = false;
		fase.setBollsQuantity( initialBollsQuantity );
		fase.getTray().init( picture );			
	}

	public void reinit() {
		endFase = false;
		fase.getTray().reinit();
	}
	
	public void finish() {			
		endFase = true;
	}
	
	public boolean isEndFase() {
		return endFase;
	}
				
	public int getInitialBollsQuantity() {
		return initialBollsQuantity;
	}

	public void setInitialBollsQuantity(int initialBollsQuantity) {
		this.initialBollsQuantity = initialBollsQuantity;
	}

	public Animation getAnimation() {
		return animation;
	}

	public void setAnimation(Animation animation) {
		this.animation = animation;
	}
	
	private void addTray(TrayAttributes trayAttributes) {
		Tray tray = new TrayVO(fase);
		tray.initialize( trayAttributes );
		fase.setTray(tray);
	}

	public Fase getFase() {
		return fase;
	}

}
