package italo.pacman.logic.game.mediator;

import italo.pacman.adapter.picture.game.LogicMessagePicture;
import italo.pacman.logic.AbstractFigureMediator;
import italo.pacman.logic.game.Message;

public class MessageMediator extends AbstractFigureMediator {

	private Message message;
	
	public MessageMediator(Message message) {
		this.message = message;
	}

	public void init(LogicMessagePicture picture) {
		picture.init(message);
		super.setLogicPicture(picture);
	}
	
	public void resize(double widthFactor, double heightFactor) {
		int trayWidth  = message.getTray().getWidth();
		int trayHeight = message.getTray().getHeight();
		int width  = (int) ( trayWidth  * widthFactor  );
		int height = (int) ( trayHeight * heightFactor );
		int x = (int) ( trayWidth  - width  ) / 2;
		int y = (int) ( trayHeight - height ) / 2;
		message.setX(x);
		message.setY(y);
		message.setWidth(width);
		message.setHeight(height);
	}
	
}
