package italo.pacman.logic.game.mediator;

import italo.pacman.adapter.picture.game.LogicMonsterPicture;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.attributes.MonsterAttributes;
import italo.pacman.logic.game.state.State;
import italo.pacman.logic.game.state.StateUtil;

public class MonsterMediator extends PersonageMediator {

	private State initialState;
	
	public MonsterMediator(Monster monstrinho) {
		super(monstrinho);
	}
	
	public void initialize(MonsterAttributes monsterAttributes) {				
		super.initialize( monsterAttributes  );				
		((Monster)super.personage).setId( monsterAttributes.getId() );
		this.initialState = StateUtil.getState( monsterAttributes.getInitialState() );		
	}
	
	public void init(LogicMonsterPicture picture) {		
		super.init(picture);
		((Monster)super.personage).setState(initialState);
	}
	
	public void reinit() {
		super.reinit();
		((Monster)super.personage).setState(initialState);
	}

	
}
