package italo.pacman.logic.game.mediator;

import italo.pacman.adapter.picture.game.LogicScorePicture;
import italo.pacman.constants.GameConstants;
import italo.pacman.logic.AbstractFigureMediator;
import italo.pacman.logic.game.Score;
import italo.pacman.logic.game.bound.Bound;

public class ScoreMediator extends AbstractFigureMediator {
	
	private Score score;
	
	public ScoreMediator(Score score) {
		this.score = score;
	}
	
	public void init(LogicScorePicture picture) {
		picture.init(score);
		super.setLogicPicture(picture);
		score.setScoreValue(GameConstants.INITIAL_SCORE);
	}
	
	public void init2() {
		score.setScoreValue(GameConstants.INITIAL_SCORE);
	}
	
	public void resize(Bound bound) {		
		int boundX = bound.getX();
		int boundY = bound.getY();
		int boundWidth = bound.getWidth();
		int boundHeight = bound.getHeight();
		
		int width  = boundWidth;
		int height = boundHeight;
		int x = ( ( boundWidth % width ) / 2 ) + boundX;
		int y = boundY;
		score.setX(x);
		score.setY(y);
		score.setWidth(width);
		score.setHeight(height);
	}

}
