package italo.pacman.logic.game.motion;

import italo.pacman.logic.game.Personage;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.direction.Direction;


public abstract class AbstractMotion implements Motion {
	
	public boolean moveToDirection(Personage personagem, Tray tabuleiro, Direction direcao) {
		if(validMotion(personagem, tabuleiro, direcao)) {
			move(personagem, tabuleiro, direcao);
			return true;
		}
		return false;
	}
	
	public boolean moveToCurrentDirection(Personage personagem, Tray tabuleiro) {
		Direction direcao = personagem.getDirection();
		return moveToDirection(personagem, tabuleiro, direcao);
	}
	
	public boolean moveToNewDirection(Personage personagem, Tray tabuleiro) {
		Direction direcao = personagem.getNewDirection();
		if(validMotion(personagem, tabuleiro, direcao)) {
			move(personagem, tabuleiro, direcao);
			personagem.setDirection(direcao);
			return true;
		}
		return false;
	}
			
	protected boolean validMotion(Personage personagem, Tray tabuleiro, Direction direcao) {
		if(direcao.validMotion(personagem, tabuleiro)) {
			if(isWithinCell(personagem, tabuleiro)) 
				return direcao.isFreeWall(personagem, tabuleiro);			
			return true;
		}
		return false;
	}

	
	protected void move(Personage personagem, Tray tabuleiro, Direction direcao) {
		tabuleiro.move(personagem, direcao);
	}
	
	private boolean isWithinCell(Personage personagem, Tray tabuleiro) {
		int x = personagem.getX();
		int y = personagem.getY();
		return tabuleiro.isWithinCell(x, y);
		
	}
		
}
