package italo.pacman.logic.game.motion;

import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Personage;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.astar.AStar;
import italo.pacman.logic.game.astar.algoritmo.AStarAlgoritmo;
import italo.pacman.logic.game.direction.Direction;


public class NearMotion extends AbstractMotion {

	public boolean move(Personage personagem, Tray tray) {				
		
		Monster monster = (Monster)personagem;
		int xP = monster.getX();
		int yP = monster.getY();	
		
		if(tray.isWithinCell(xP, yP)) {						
			Pacman pacman   = tray.getPacman(); 
			AStar astar = new AStarAlgoritmo();
			boolean routeFounded = astar.execute(tray, monster, pacman);				
			if(routeFounded) {				
				int xOptimalCell = astar.getOptimunRouteCells().getLast().getX();
				int yOptimalCell = astar.getOptimunRouteCells().getLast().getY();				
				int cellWidth = tray.getCell().getWidth();
				int cellHeight = tray.getCell().getHeight();			
				int currentCellX = xP / cellWidth;
				int currentCellY = yP / cellHeight;				
				Direction betterDirection = Direction.RIGHT_DIRECTION;
				Direction[] directions = Direction.DIRECTIONS;
				int[][] directionsXY = Direction.DIRECTIONS_XY_CELL;
				for(int i = 0; i < directions.length; i++) {				
					int x = currentCellX + directionsXY[i][0];
					int y = currentCellY + directionsXY[i][1]; 
					Direction direction = directions[i];
					if(x == xOptimalCell && y == yOptimalCell) {						
						betterDirection = direction;
						break;
					}
				}					
				boolean moveu = super.moveToDirection(personagem, tray, betterDirection);
				if(moveu) {
					monster.setDirection( betterDirection );
					monster.setOptimunRouteCells( astar.getOptimunRouteCells() );
					monster.setRouteVisible(true);
				}
				return moveu;				
			} else { 
				monster.setRouteVisible(false);
				return RANDOM_MOTION.move(personagem, tray);
			}
		} else {	
			return RANDOM_MOTION.move(personagem, tray);	
		}
	}

}
