package italo.pacman.logic.game.motion;

import italo.pacman.logic.game.Personage;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.direction.Direction;
import italo.pacman.utilities.VectorUtil;

public class RandomMotion extends AbstractMotion {

	public boolean move(Personage personagem, Tray tabuleiro) {		
		boolean moveu = super.moveToCurrentDirection(personagem, tabuleiro);
		if(!moveu) {
			Direction direcaoAtual = personagem.getDirection();
			Direction[] direcoesRestantes = direcaoAtual.getRemainderDirection();
			int[] indicesRandom = VectorUtil.random(direcoesRestantes.length-1);
			for(int i = 0; i < direcoesRestantes.length && !moveu; i++) {
				int indice = (i < indicesRandom.length ? indicesRandom[i] : i);
				Direction direcao = direcoesRestantes[indice];
				moveu = super.moveToDirection(personagem, tabuleiro, direcao);
				if(moveu)
					personagem.setDirection(direcao); 
			}
		}
		return moveu;
	}

}
