package italo.pacman.logic.game.state;

import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.difficulty.Difficulty;

public class MuchWeakState extends AbstractState {

	public boolean move(Monster monstrinho, Tray tabuleiro, Difficulty dificuldade) {
		boolean moveu = super.moveToHouseWall(monstrinho, tabuleiro);
		if(moveu) {
			monstrinho.enterInHouse();
		} else {
			moveu = super.moveRandomly(monstrinho, tabuleiro);
		}
		return moveu;
		
	}
	
	public int getSpeed(Monster monstrinho) {
		double velocidade = (double) monstrinho.getSpeed();
		return (int) (velocidade * COEFICIENTE_VELOCIDADE_ESTADO_MUITO_FRACO);
	}

	public boolean finalizeTimeStateThread() {
		return true;
	}
	
	public String getString() {
		return STRING_MUCH_WEAK_STATE;
	}
	
}
