package italo.pacman.logic.game.state;

import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.difficulty.Difficulty;


public class StrongState extends AbstractState {

	public boolean move(Monster monster, Tray tray, Difficulty difficulty) {
		boolean moveu = this.moveToWithoutFromHouse(monster, tray);
		if(!moveu) {
			if(difficulty.personagesNear(monster, tray.getPacman(), tray)) {
				moveu = super.moveToNear(monster, tray, difficulty);				
			} else {
				monster.setRouteVisible(false);
				moveu = super.moveToWay(monster, tray, difficulty);
			}
		}
		return moveu;
	}
			
	public void haveCollision(Monster monstrinho, Pacman comecome) {
		monstrinho.catchPacman(comecome);
	}
			
	public int getSpeed(Monster monstrinho) {
		double velocidade = (double) monstrinho.getSpeed();
		return (int) (velocidade * COEFICIENTE_VELOCIDADE_ESTADO_FORTE);
	}
	
	public boolean finalizeTimeStateThread() {
		return true;
	}
	
	public String getString() {
		return STRING_STRONG_STATE;
	}
	
}
