package italo.pacman.logic.game.state;

import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.difficulty.Difficulty;

public class WeakState extends AbstractState {
	
	public boolean move(Monster monstrinho, Tray tabuleiro, Difficulty dificuldade) {
		boolean moveu = this.moveToWithoutFromHouse(monstrinho, tabuleiro);
		if(!moveu)
			moveu = super.moveToWay(monstrinho, tabuleiro, dificuldade);		
		return moveu;
	}
	
	public int getSpeed(Monster monstrinho) {
		double velocidade = (double) monstrinho.getSpeed();
		return (int) (velocidade * COEFICIENTE_VELOCIDADE_ESTADO_FRACO);
	}
	
	public void haveCollision(Monster monstrinho, Pacman comecome) {
		comecome.eatMonster(monstrinho);
	}

	public boolean finalizeTimeStateThread() {
		return false;
	}
	
	public String getString() {
		return STRING_WEAK_STATE;
	}
	
}
