package italo.pacman.logic.game.vo;

import italo.pacman.adapter.figure.AbstractComponentFigure;
import italo.pacman.adapter.figure.game.TrayFigure;
import italo.pacman.adapter.picture.game.LogicBigBollPicture;
import italo.pacman.logic.game.BigBoll;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.mediator.BigBollMediator;

import java.awt.Image;

public class BigBollVO extends AbstractComponentFigure implements BigBoll {

	private int[][] bigBolls;
	
	private BigBollMediator mediator;
	private Tray tray;
	
	public BigBollVO(Tray tray) {
		super(tray, 0, 0, 0, 0);
		this.mediator = new BigBollMediator(this);
		this.tray = tray;
	}
	
	public void init(LogicBigBollPicture picture) {
		mediator.init(picture);
	}
	
	public void setImage(Image image) {
		mediator.setImage(image);
	}

	public void setBigBolls(int[][] bigBolls) {
		this.bigBolls = bigBolls;
	}

	public int[][] getBigBolls() {
		return bigBolls;
	}

	public Tray getTray() {
		return tray;
	}
	
	public TrayFigure getTrayFigure() {
		return tray;
	}
	
	public boolean[][] getBolls() {
		return tray.getBoll().getBolls();
	}

}
