package italo.pacman.logic.game.vo;

import italo.pacman.adapter.figure.AbstractComponentFigure;
import italo.pacman.adapter.figure.game.TrayFigure;
import italo.pacman.adapter.picture.game.LogicBollPicture;
import italo.pacman.logic.game.Boll;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.mediator.BollMediator;

import java.awt.Image;

public class BollVO extends AbstractComponentFigure implements Boll {

	private boolean[][] bolls;
	
	private BollMediator mediator;	
	private Tray tray;
	
	public BollVO(Tray tray) {
		super(tray, 0, 0, 0, 0);
		this.mediator = new BollMediator(this);
		this.tray = tray;
	}
	
	public void init(LogicBollPicture picture) {
		mediator.init(picture);
	}
	
	public void setImage(Image image) {
		mediator.setImage(image);
	}

	public void setBolls(boolean[][] bolls) {
		this.bolls = bolls;
	}

	public boolean[][] getBolls() {
		return bolls;
	}

	public Tray getTray() {
		return tray;
	}
	
	public TrayFigure getTrayFigure() {
		return tray;
	}

}
