package italo.pacman.logic.game.vo;

import italo.pacman.adapter.figure.AbstractComponentFigure;
import italo.pacman.adapter.picture.game.LogicCellPicture;
import italo.pacman.logic.game.Cell;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.mediator.CellMediator;

import java.awt.Image;


public class CellVO extends AbstractComponentFigure implements Cell {
		
	private CellMediator mediator;
	private Tray tray;
	
	public CellVO(Tray tray, int width, int height) {
		super(tray, 0, 0, width, height);
		this.mediator = new CellMediator(this);
		this.tray = tray;
	}
	
	public void init(LogicCellPicture picture) {
		mediator.init(picture);
	}
	
	public void setImage(Image image) {
		mediator.setImage(image);
	}
	
	public CellVO(Tray tray) {
		this(tray, 0, 0);
	}

	public Tray getTray() {
		return tray;
	}
	
}
