package italo.pacman.logic.game.vo;

import italo.pacman.adapter.figure.AbstractComponentFigure;
import italo.pacman.adapter.picture.game.LogicHousePicture;
import italo.pacman.logic.game.House;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.mediator.HouseMediator;

import java.awt.Image;

public class HouseVO extends AbstractComponentFigure implements House {
		
	private int[][] cellIndexes;
	private int[][] horizontalDoorIndexes;
	private int[][] verticalDoorIndexes;
	
	private HouseMediator mediator;
	
	private Tray tray;
	
	protected HouseVO(Tray tray) {
		super(tray, 0, 0, 0, 0);
		this.mediator = new HouseMediator(this);
		this.tray = tray;
	}
	
	public void init(LogicHousePicture picture) {
		mediator.init(picture);
	}
	
	public void setImage(Image image) {
		mediator.setImage(image);
	}
	
	public int[][] getCellIndexes() {
		return cellIndexes;
	}
	
	public void setCellIndexes(int[][] cellIndexes) {
		this.cellIndexes = cellIndexes;
	}

	public int[][] getHorizontalDoorIndexes() {
		return horizontalDoorIndexes;
	}

	public void setHorizontalDoorIndexes(int[][] horizontalDoorIndexes) {
		this.horizontalDoorIndexes = horizontalDoorIndexes;
	}

	public int[][] getVerticalDoorIndexes() {
		return verticalDoorIndexes;
	}

	public void setVerticalDoorIndexes(int[][] verticalDoorIndexes) {
		this.verticalDoorIndexes = verticalDoorIndexes;
	}

	public Tray getTray() {
		return tray;
	}

}
