package italo.pacman.logic.game.vo;

import italo.pacman.adapter.figure.AbstractComponentFigure;
import italo.pacman.adapter.picture.game.LogicMessagePicture;
import italo.pacman.logic.game.Message;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.mediator.MessageMediator;

import java.awt.Image;

public class MessageVO extends AbstractComponentFigure implements Message {

	private boolean visible;
	
	private MessageMediator mediator;

	private Tray tray;
	
	public MessageVO(Tray tray, int x, int y, int width, int height) {
		super(tray, x, y, width, height);
		this.mediator = new MessageMediator(this);
		this.tray = tray;
		this.visible = false;
	}

	public MessageVO(Tray tray) {
		this(tray, 0, 0, 0, 0);
	}
	
	public void init(LogicMessagePicture picture) {
		mediator.init(picture);
	}
	
	public void resize(double widthFactor, double heightFactor) {
		mediator.resize(widthFactor, heightFactor);
	}
	
	public void setImage(Image image) {
		mediator.setImage(image);
	}

	public boolean isVisible() {
		return visible;
	}

	public void setVisible(boolean visible) {
		this.visible = visible;
	}

	public Tray getTray() {
		return tray;
	}

}
