package italo.pacman.logic.game.vo;


import italo.pacman.adapter.picture.game.LogicPacmanPicture;
import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Tray;
import italo.pacman.logic.game.attributes.PacmanAttributes;
import italo.pacman.logic.game.event.PacmanListener;
import italo.pacman.logic.game.mediator.PersonageMediator;

public class PacmanVO extends PersonageVO implements Pacman {
	
	private PacmanListener listener;		
	
	public PacmanVO(Tray tray, int sleep) {
		super(0, 0, 0, 0, tray, PACMAN, ID_COMECOME, sleep);
		super.mediator = new PersonageMediator(this);
	}
	
	public PacmanVO(Tray tray) {		
		this(tray, 0);
	}
	
	public void setPacmanListener(PacmanListener listener) {
		this.listener = listener;
	}
	
	public void removePacmanListener() {
		this.listener = null;
	}
	
	public void eatBoll() {
		if(listener != null)
			listener.eatBoll(this);
	}
	
	public void eatBigBoll() {
		if(listener != null)
			listener.eatBigBoll(this);
	}
	
	public void eatMonster(Monster monstrinho) {
		if(listener != null)
			listener.eatMonster(this, monstrinho);
	}
			
	public void initialize(PacmanAttributes attributes) {
		mediator.initialize(attributes);
	}
		
	public void init(LogicPacmanPicture picture) {
		mediator.init(picture);
	}
	
	public boolean canCrossWall() {
		return PACMAN_CROSS_WALL;
	}
	
	public boolean crossWall() {
		return canCrossWall() && tray.getFase().getGame().isCrossWall();
	}

}
