package italo.pacman.logic.game.vo;

import italo.pacman.adapter.figure.AbstractComponentFigure;
import italo.pacman.adapter.picture.abertura.LogicProgressBarPicture;
import italo.pacman.logic.abertura.Abertura;
import italo.pacman.logic.game.ProgressBar;
import italo.pacman.logic.game.mediator.ProgressBarMediator;

import java.awt.Image;

public class ProgressBarVO extends AbstractComponentFigure implements ProgressBar {

	private int percentage;
	
	private ProgressBarMediator mediator;
	private Abertura abertura;
			 	
	public ProgressBarVO(Abertura abertura, int x, int y, int width, int height) {
		super(abertura, x, y, width, height);
		this.mediator = new ProgressBarMediator(this);
		this.abertura = abertura;
	}
	
	public ProgressBarVO(Abertura abertura) {
		this(abertura, 0, 0, 0, 0);
		this.mediator = new ProgressBarMediator(this);
	}
	
	public void init(LogicProgressBarPicture picture) {
		mediator.init(picture);
	}
	
	public void setImage(Image image) {
		mediator.setImage(image);
	}
	
	public int getPercentage() {
		return percentage;
	}

	public void setPercentage(int percentage) {
		this.percentage = percentage;
	}

	public Abertura getAbertura() {
		return abertura;
	}

}
