package italo.pacman.logic.mediator;

import italo.pacman.logic.Sistema;
import italo.pacman.logic.game.Load;
import italo.pacman.multimidia.MidiaLoad;



public class SistemaMediator implements Load {
	
	private Sistema sistema;
	private boolean endSistema;
	
	public SistemaMediator(Sistema sistema) {
		this.sistema = sistema;
		this.endSistema = false;
	}
		
	public void load(int nFiles) {		
		MidiaLoad midiaLoad = new MidiaLoadControl(this, nFiles);
		sistema.load(midiaLoad);
	}
	
	public void loading(int percentage) {
		sistema.getAbertura().setPercentage(percentage);
		sistema.loading(percentage);
	}

	public void init() {
		endSistema = false;
	}
	
	public void finish() {
		endSistema = true;		
	}

	public boolean isEndSistema() {
		return endSistema;
	}
	
}
