package italo.pacman.multimidia;

import italo.pacman.multimidia.midia.AudioMidia;
import italo.pacman.multimidia.midia.audio.AudioFase;
import italo.pacman.multimidia.midia.audio.AudioVida;

import java.applet.AudioClip;

class AudioManager {

	private static AudioManager singleton = null;
	
	private AudioManager() {}
		
	static AudioManager getInstance() {
		if(singleton == null) {
			synchronized(AudioManager.class) {
				singleton = new AudioManager();
			}
		}
		return singleton;
	}

	public AudioClip getAudio(String name) {
		AudioMidia midia = new AudioMidia(name);
		String caminho = midia.getCaminho();
		return AudioController.getInstance().getAudioClip(caminho);
	}

	public AudioClip getAudioFase(String name) {
		AudioMidia midia = new AudioFase(name);
		String caminho = midia.getCaminho();
		return AudioController.getInstance().getAudioClip(caminho);
	}

	public AudioClip getAudioVida(String name) {
		AudioMidia midia = new AudioVida(name);
		String caminho = midia.getCaminho();
		return AudioController.getInstance().getAudioClip(caminho);
	}
	
	
}
