package italo.pacman.multimidia;

import italo.pacman.logic.game.Monster;
import italo.pacman.logic.game.Pacman;
import italo.pacman.logic.game.Personage;
import italo.pacman.multimidia.midia.Midia;
import italo.pacman.multimidia.midia.image.ImagemEncerramento;
import italo.pacman.multimidia.midia.image.ImagemAbertura;
import italo.pacman.multimidia.midia.image.ImagemMensagem;
import italo.pacman.multimidia.midia.image.ImagemTabuleiro;
import italo.pacman.multimidia.midia.image.ImagemVida;

import java.awt.Image;

class ImageManager {

	private static ImageManager singleton = null;
	
	private ImageManager() {}
		
	static ImageManager getInstance() {
		if(singleton == null) {
			synchronized(ImageManager.class) {
				singleton = new ImageManager();
			}
		}
		return singleton;
	}
	
	public Image getImagemTabuleiro(String nome) {
		Midia midia = new ImagemTabuleiro(nome);
		String caminho = midia.getCaminho();
		return ImageController.getInstance().getImage(caminho);		
	}
	
	public Image getImagemAbertura(String nome) {
		Midia midia = new ImagemAbertura(nome);
		String caminho = midia.getCaminho();
		return ImageController.getInstance().getImage(caminho);		
	}
	
	public Image getImagemEncerramento(String nome) {
		Midia midia = new ImagemEncerramento(nome);
		String caminho = midia.getCaminho();
		return ImageController.getInstance().getImage(caminho);		
	}
	
	public Image getImagemMensagem(String nome) {
		Midia midia = new ImagemMensagem(nome);		
		String caminho = midia.getCaminho();
		return ImageController.getInstance().getImage(caminho);	
	}
	
	public Image getImagemMensagemVida(String nome) {
		Midia midia = new ImagemVida(nome);
		String caminho = midia.getCaminho();
		return ImageController.getInstance().getImage(caminho);	
	}
	
	public Image getImagemPersonagem(Personage personagem, Animation animador) {
		String caminho;
		if(personagem instanceof Monster) {			
			String id = ((Monster)personagem).getId();
			String estado = ((Monster)personagem).getState().getString();
			caminho = animador.getMonsterPath(id, estado);
		} else {
			String direcao = ((Pacman)personagem).getDirection().getString();
			caminho = animador.getPacmanPath(direcao);						
		}
		return ImageController.getInstance().getImage(caminho);	
	}
		
}
