package italo.pacman.multimidia;

import italo.pacman.logic.game.Personage;

import java.applet.AudioClip;
import java.awt.Image;



public class MultimidiaFacade implements Multimidia {

	private static Multimidia singleton = null;
	
	private MultimidiaFacade() {}
				
	public static Multimidia getInstance() {
		if(singleton == null) {
			synchronized(MultimidiaFacade.class) {
				singleton = new MultimidiaFacade();
			}
		}
		return singleton;
	}
	
	public void initialize(MidiaResource urlFile) {
		ImageController.getInstance().initialize(urlFile);
		AudioController.getInstance().initialize(urlFile);
	}
	
	public void imageLoad(String imagePath) {
		ImageController.getInstance().load(imagePath);
	}
	
	public void imagesLoad(String[] imagesPath, MidiaLoad load) {
		ImageController.getInstance().load(imagesPath, load);
	}
	
	public void audiosLoad(String[] audiosPath, MidiaLoad load) {
		AudioController.getInstance().load(audiosPath, load);
	}
	
	public void executeAudio(String name) {
		AudioClip audioClip = AudioManager.getInstance().getAudio(name);
		AudioController.getInstance().execute(audioClip);		
	}
	
	public void executeAudioFase(String name) {		
		AudioClip audioClip = AudioManager.getInstance().getAudioFase(name);
		AudioController.getInstance().execute(audioClip);
	}
	
	public void executeAudioVida(String name) {		
		AudioClip audioClip = AudioManager.getInstance().getAudioVida(name);
		AudioController.getInstance().execute(audioClip);
	}
	
	
	public Image getImagemTabuleiro(String nome) {
		return ImageManager.getInstance().getImagemTabuleiro(nome);
	}
	
	public Image getImagemAbertura(String nome) {
		return ImageManager.getInstance().getImagemAbertura(nome);
	}
	
	public Image getImagemEncerramento(String nome) {
		return ImageManager.getInstance().getImagemEncerramento(nome);
	}
	
	public Image getImagemMensagem(String nome) {
		return ImageManager.getInstance().getImagemMensagem(nome);
	}
	
	public Image getImagemMensagemVida(String nome) {
		return ImageManager.getInstance().getImagemMensagemVida(nome);
	}
	
	public Image getImagemPersonagem(Personage personagem, Animation animador) {
		return ImageManager.getInstance().getImagemPersonagem(personagem, animador);
	}
	
	public boolean isExecuteAudio() {
		return AudioController.getInstance().isExecuteAudio();
	}
	
	public void setExecuteAudio(boolean execute) {
		AudioController.getInstance().setExecuteAudio(execute);
	}
			
}
