package italo.pacman.picture;


import italo.pacman.picture.image.ComponentImagePicture;
import italo.pacman.picture.image.ImagePicture;

import java.awt.Image;

public abstract class AbstractComponentPicture implements ComponentPicture {

	protected ImagePicture imagePicture;
	protected ContainerPicture container;
	
	protected AbstractComponentPicture(ContainerPicture container) {
		this.container = container;
		this.imagePicture = new ComponentImagePicture();
	}
	
	public Image getImage() {
		return imagePicture.getImage();
	}
	
	public void setImage(Image image) {
		imagePicture.setImage( image );
	}

	public ContainerPicture getContainer() {
		return container;
	}

}
