package italo.pacman.picture;


import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

public abstract class AbstractContainerPicture extends AbstractComponentPicture implements ContainerPicture {

	protected List<ComponentPicture> components = new CopyOnWriteArrayList<ComponentPicture>();
			
	protected AbstractContainerPicture(ContainerPicture container) {
		super(container);
	}
		
	public void add(ComponentPicture component) {
		components.add(component);
	}

	public List<ComponentPicture> getComponents() {		
		return components;
	}

	public void remove(ComponentPicture component) {
		components.remove(component);
	}
	
	public void removeAll() {
		components.clear();
	}

}
