package italo.pacman.picture.abertura;

import italo.pacman.adapter.figure.abertura.AberturaFigure;
import italo.pacman.adapter.picture.abertura.LogicAberturaPicture;
import italo.pacman.adapter.picture.abertura.LogicProgressBarPicture;
import italo.pacman.picture.AbstractContainerPicture;
import italo.pacman.picture.ComponentPicture;

import java.awt.Graphics;

public class AberturaPicture extends AbstractContainerPicture implements LogicAberturaPicture {
	
	private ProgressBarPicture progressBarPicture = new ProgressBarPicture(this);
	private AberturaFigure aberturaFigure;
	
	public AberturaPicture() {
		super(null);
	}
	
	public void init(AberturaFigure aberturaFigure) {
		this.aberturaFigure = aberturaFigure;
		super.imagePicture.setComponent(aberturaFigure);
		super.removeAll();
		super.add( progressBarPicture );
	}
			
	public void paint(Graphics g) {
		if(imagePicture != null)
			imagePicture.paint(g);
		for(ComponentPicture component:components)
			component.paint(g);
	}

	public LogicProgressBarPicture getProgressBarPicture() {
		return progressBarPicture;
	}

	public AberturaFigure getAberturaFigure() {
		return aberturaFigure;
	}
		
}
