package italo.pacman.picture.abertura;

import italo.pacman.adapter.figure.abertura.ProgressBarFigure;
import italo.pacman.adapter.picture.abertura.LogicProgressBarPicture;
import italo.pacman.picture.AbstractComponentPicture;
import italo.pacman.picture.ContainerPicture;

import java.awt.Color;
import java.awt.Graphics;

public class ProgressBarPicture extends AbstractComponentPicture implements LogicProgressBarPicture {
		
	public final static Color COR_BARRA_PROGRESSO = Color.WHITE;
	public final static Color COR_PORCENTAGEM = Color.GREEN;
		
	private ProgressBarFigure progressBarFigure;
	
	public ProgressBarPicture(ContainerPicture aberturaPicture) {
		super(aberturaPicture);
	}
	
	public void init(ProgressBarFigure figure) {
		super.imagePicture.setComponent(figure);
		this.progressBarFigure = figure;
		
	}
			
	public void paint(Graphics g) {
		progressBarPaint(g);				
	}
	
	private void progressBarPaint(Graphics g) {
		int percentage = progressBarFigure.getPercentage();
		int xPB = progressBarFigure.getX();
		int yPB = progressBarFigure.getY();
		int widthPB  = progressBarFigure.getWidth();
		int heightPB = progressBarFigure.getHeight();		
		int widthAreaFilled = (int)( percentage * ( widthPB/100 ) );		
		g.setColor(COR_BARRA_PROGRESSO);
		g.drawRect(xPB, yPB, widthPB, heightPB);
		g.fillRect(xPB, yPB, widthAreaFilled, heightPB); 
		g.setColor(COR_PORCENTAGEM);
		g.drawString(String.valueOf(percentage)+"%", 
				(int)(xPB+(widthPB*0.48)), (int)(yPB+(heightPB*0.75))); 
	}

	public ProgressBarFigure getProgressBarFigure() {
		return progressBarFigure;
	}
		
}
