package italo.pacman.picture.encerramento;

import italo.pacman.adapter.figure.encerramento.EncerramentoFigure;
import italo.pacman.adapter.picture.encerramento.LogicEncerramentoPicture;
import italo.pacman.picture.AbstractContainerPicture;
import italo.pacman.picture.ComponentPicture;

import java.awt.Graphics;

public class EncerramentoPicture extends AbstractContainerPicture implements LogicEncerramentoPicture {
	
	private EncerramentoFigure encerramentoFigure;
		
	public EncerramentoPicture() {
		super(null);
	} 
	
	public void init(EncerramentoFigure encerramentoFigure) {
		this.encerramentoFigure = encerramentoFigure;
		super.imagePicture.setComponent(encerramentoFigure);
		super.removeAll();
	}
			
	public void paint(Graphics g) {
		if(imagePicture != null)
			imagePicture.paint(g);
		for(ComponentPicture component:components)
			component.paint(g);
	}

	public EncerramentoFigure getEncerramentoFigure() {
		return encerramentoFigure;
	}
		
}
