package italo.pacman.picture.game;

import italo.pacman.adapter.figure.game.GameFigure;
import italo.pacman.adapter.picture.game.LogicGamePicture;
import italo.pacman.adapter.picture.game.LogicScorePicture;
import italo.pacman.picture.AbstractContainerPicture;
import italo.pacman.picture.ComponentPicture;
import italo.pacman.picture.game.score.ScorePicture;
import italo.pacman.picture.game.tray.TrayPicture;

import java.awt.Graphics;

public class GamePicture extends AbstractContainerPicture implements LogicGamePicture {
		
	private TrayPicture trayPicture = new TrayPicture(this);
	private ScorePicture scorePicture = new ScorePicture(this);
			
	public GamePicture() {
		super(null);		
	}
	
	public void init(GameFigure gameFigure) {
		super.imagePicture.setComponent(gameFigure);
		super.removeAll();
		super.add( trayPicture  );
		super.add( scorePicture );
	}
	
	public void paint(Graphics g) {
		for(ComponentPicture component:components)
			component.paint(g);
	}

	public TrayPicture getTrayPicture() {
		return trayPicture;
	}

	public LogicScorePicture getScorePicture() {
		return scorePicture;
	}

}
