package italo.pacman.picture.game.tray;

import italo.pacman.adapter.figure.game.BigBollFigure;
import italo.pacman.adapter.figure.game.TrayFigure;
import italo.pacman.adapter.picture.game.LogicBigBollPicture;
import italo.pacman.picture.AbstractComponentPicture;
import italo.pacman.picture.ContainerPicture;

import java.awt.Graphics;
import java.awt.Graphics2D;

public class BigBollPicture extends AbstractComponentPicture implements LogicBigBollPicture {
	
	private BigBollFigure bigBollFigure;
	
	public BigBollPicture(ContainerPicture container) {
		super(container);
	}

	public void init(BigBollFigure bigBollFigure) {
		super.imagePicture.setComponent(bigBollFigure);
		this.bigBollFigure = bigBollFigure;
	}
	
	public void paint(Graphics g) {		
		if(bigBollFigure != null) {
			Graphics2D g2D = (Graphics2D)g;
			TrayFigure tray = bigBollFigure.getTrayFigure();
			boolean[][] bolls = bigBollFigure.getBolls();
			int[][] bigBolls = bigBollFigure.getBigBolls();
			g2D.setColor(COR_BOLINHA_GRANDE);
			int xT = tray.getX();
			int yT = tray.getY();
			int cellWidth = tray.getCellFigure().getWidth();
			int cellHeight = tray.getCellFigure().getHeight();
			for(int i = 0; i < bigBolls.length; i++) {
				int xB = bigBolls[i][0];
				int yB = bigBolls[i][1];
				if(xB >= 0 && yB >= 0 && bolls[yB][xB]) {
					int cellX = xB/2 * cellWidth;
					int cellY = yB/2 * cellHeight;						
					int meiaLC = cellWidth/2;
					int meiaAC = cellHeight/2;	
					int x = xT + meiaLC + cellX + (xB%2 == 1 ? meiaLC : 0);
					int y = yT + meiaAC + cellY + (yB%2 == 1 ? meiaAC : 0);
					g2D.fillArc(x, y, LARGURA_BOLINHA_GRANDE, ALTURA_BOLINHA_GRANDE, 0, 360);
				}
			}	
		}
	}
	
}
