package italo.pacman.picture.game.tray;

import italo.pacman.adapter.figure.game.BollFigure;
import italo.pacman.adapter.figure.game.TrayFigure;
import italo.pacman.adapter.picture.game.LogicBollPicture;
import italo.pacman.picture.AbstractComponentPicture;
import italo.pacman.picture.ContainerPicture;

import java.awt.Graphics;
import java.awt.Graphics2D;

public class BollPicture extends AbstractComponentPicture implements LogicBollPicture {
	
	private BollFigure bollFigure;
	
	public BollPicture(ContainerPicture container) {
		super(container);
	}
	
	public void init(BollFigure bollFigure) {
		super.imagePicture.setComponent(bollFigure);
		this.bollFigure = bollFigure;
		
	}

	public void paint(Graphics g) {	
		if(bollFigure != null) {
			Graphics2D g2D = (Graphics2D)g;
			boolean[][] bolls = bollFigure.getBolls();
			TrayFigure tray = bollFigure.getTrayFigure();
			int xT = tray.getX();
			int yT = tray.getY();
			int cellWidth = tray.getCellFigure().getWidth();
			int cellHeight = tray.getCellFigure().getHeight();
			g2D.setColor(COR_BOLINHA);
			for(int i = 0; i < bolls.length; i++) {
				boolean[] vetorB = bolls[i];
				for(int j = 0; j < vetorB.length; j++) {
					if(vetorB[j]) {
						int cellX = j/2 * cellWidth;
						int cellY = i/2 * cellHeight;						
						int meiaLC = cellWidth  / 2;
						int meiaAC = cellHeight / 2;						
						int x = xT + meiaLC + cellX + (j%2 == 1 ? meiaLC : 0);
						int y = yT + meiaAC + cellY + (i%2 == 1 ? meiaAC : 0);
						g2D.fillArc(x, y, LARGURA_BOLINHA, ALTURA_BOLINHA, 0, 360);
					}
				}
			}
		}
	}
	
}