package italo.pacman.picture.game.tray;

import italo.pacman.adapter.figure.game.MonsterFigure;
import italo.pacman.adapter.picture.game.LogicMonsterPicture;
import italo.pacman.logic.game.astar.AStarCellPosition;
import italo.pacman.picture.ContainerPicture;
import italo.pacman.utilities.Utilities;

import java.awt.Graphics;
import java.util.List;

public class MonsterPicture extends PersonagePicture implements LogicMonsterPicture {

	public final static int BOLL_MIN_DIMENSION = 5;
	public final static int BOLL_MAX_DIMENSION = 25;
			
	public MonsterPicture(ContainerPicture container) {
		super(container);
	}
	
	public void init(MonsterFigure figure) {
		super.init(figure);		
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		MonsterFigure monsterFigure = ((MonsterFigure)personageFigure);
		if(monsterFigure.isRouteVisible()) {						
			List<AStarCellPosition> cells = monsterFigure.getOptimunRouteCells(); 
			
			int xT = personageFigure.getTrayFigure().getX();
			int yT = personageFigure.getTrayFigure().getY();
			
			int widthCell  = personageFigure.getTrayFigure().getCellFigure().getWidth();
			int heightCell = personageFigure.getTrayFigure().getCellFigure().getHeight();
						
			int interval = BOLL_MAX_DIMENSION - BOLL_MIN_DIMENSION;
			
			for(int i = 0; i < cells.size(); i++) {
				AStarCellPosition cell = cells.get(i);								
				double porcent =  ( (double) (cells.size()-i) ) / cells.size();
				int bollDimension = (int) ( BOLL_MIN_DIMENSION + ( interval * porcent ) );				
				int x = xT + ( cell.getX() * widthCell  ) + ( ( widthCell  - bollDimension ) / 2 );
				int y = yT + ( cell.getY() * heightCell ) + ( ( heightCell - bollDimension ) / 2 );
				g.setColor( Utilities.getRandomColor() );
				g.fill3DRect(x, y, bollDimension, bollDimension, true);
			}	
		}
	}
				
}
