package italo.pacman.picture.game.tray;

import italo.pacman.adapter.figure.game.PersonageFigure;
import italo.pacman.adapter.figure.game.TrayFigure;
import italo.pacman.adapter.picture.game.LogicPersonagePicture;
import italo.pacman.picture.AbstractComponentPicture;
import italo.pacman.picture.ContainerPicture;

import java.awt.Graphics;

public abstract class PersonagePicture extends AbstractComponentPicture implements LogicPersonagePicture {
	
	protected PersonageFigure personageFigure;
	
	protected PersonagePicture(ContainerPicture container) {
		super(container);
	}
	
	public void init(PersonageFigure figure) {
		super.imagePicture.setComponent(figure);
		this.personageFigure = figure;
	}

	public void paint(Graphics g) {
		
		TrayFigure tray = personageFigure.getTrayFigure();
		
		int cellWidth  = tray.getCellFigure().getWidth();
		int cellHeight = tray.getCellFigure().getHeight();
		
		int x = personageFigure.getX();
		int y = personageFigure.getY();
		int width = personageFigure.getWidth();
		int height = personageFigure.getHeight();
		
		personageFigure.setX( x + ( cellWidth  - width  ) / 2 );
		personageFigure.setY( y + ( cellHeight - height ) / 2 );
				
		if(imagePicture != null)
			imagePicture.paint(g);
		
		personageFigure.setX( x );
		personageFigure.setY( y );
	}
	
}
