package italo.pacman.picture.image;



import java.awt.Image;
import java.awt.image.ImageObserver;

import javax.swing.JPanel;

public abstract class AbstractImagePicture implements ImagePicture {

	protected Image image;
	protected ImageObserver imageObserver;
	
	public AbstractImagePicture(Image image, ImageObserver imageObserver) {
		this.image = image;
		this.imageObserver = imageObserver;
	}
	
	public AbstractImagePicture(Image image) {
		this(image, null);
	}
	
	public AbstractImagePicture(ImageObserver imageObserver) {
		this(null, imageObserver);
	}
	
	public AbstractImagePicture() {
		this(null, null);
	}

	public ImageObserver getImageObserver() {
		if(imageObserver == null)
			return new JPanel();
		return imageObserver;
	}
	
	public Image getImage() {
		return image;
	}

	public void setImage(Image image) {
		this.image = image;
	}
	
	public void setImageObserver(ImageObserver imageObserver) {
		this.imageObserver = imageObserver;
	}

}
