package italo.pacman.picture.image;


import italo.pacman.adapter.figure.ComponentFigure;
import italo.pacman.adapter.figure.ContainerFigure;

import java.awt.Graphics;
import java.awt.Image;

public class ComponentImagePicture extends AbstractImagePicture {

	private ComponentFigure component;
	
	public ComponentImagePicture(Image image, ComponentFigure component) {
		super(image);
		this.component = component;
	}
	
	public ComponentImagePicture(Image image) {
		this(image, null);
	}
	
	public ComponentImagePicture(ComponentFigure container) {
		this(null, container);
	}
	
	public ComponentImagePicture() {
		this(null, null);
	}
			
	public void paint(Graphics g) {
		if(image != null) {
			int xTela = getXContainer();
			int yTela = getYContainer();
			int x = xTela+component.getX();
			int y = yTela+component.getY();
			int largura = component.getWidth();
			int altura = component.getHeight();
			g.drawImage(image, x, y, largura, altura, imageObserver);
		} else {
			throw new RuntimeException("IMAGEM "+image+" FIGURA: "+component.getClass().getName()+" <--> "+component);
		}
	}

	private int getXContainer() {
		ContainerFigure container = component.getContainer();
		if(container != null)
			return container.getX();
		return 0;
	}
	
	private int getYContainer() {
		ContainerFigure container = component.getContainer();
		if(container != null)
			return container.getY();
		return 0;
	}

	public ComponentFigure getComponent() {
		return component;
	}

	public void setComponent(ComponentFigure component) {
		this.component = component;
	}
	
}
