package italo.pacman.trick;

import java.util.ArrayList;
import java.util.List;

public class Trick implements TrickListener {

	public final static char CORINGA = '?';
	
	public final static int TRICK_ACTIVE = 1;
	public final static int TRICK_NOT_ACTIVE = 2;
		
	private char[] trickCharacters;
	private char[] trickDigitado; 
	private int index;
	private int status = TRICK_NOT_ACTIVE;
	private List<TrickListener> trickListeners = new ArrayList<TrickListener>();
	
	public Trick(char[] truque) {
		this.trickCharacters = truque;
		this.trickDigitado = new char[truque.length];
		this.index = 0;
	}
	
	public void keyPressed(char key) {	
		char teclaDigitada = Character.toLowerCase(key);
		char teclaTruque = Character.toLowerCase(trickCharacters[index]);
		if(teclaDigitada == teclaTruque || teclaTruque == CORINGA) {
			trickDigitado[index] = teclaDigitada;			
			if(index < trickCharacters.length-1) {				
				index++;
			} else {
				index = 0;
				status = (status == TRICK_ACTIVE ? TRICK_NOT_ACTIVE: TRICK_ACTIVE);
				trickFinish(this);	
			}
		} else {
			index = 0;
		}		
	}
	
	public void trickFinish(Trick truque) {
		List<TrickListener> listeners = truque.getTrickListeners();
		for(TrickListener l:listeners)
			l.trickFinish(truque);
	}

	public void addTrickListener(TrickListener listener) {
		trickListeners.add(listener);
	}
	
	public void removeTrickListener(TrickListener listener) {
		trickListeners.remove(listener);
	}

	public char[] getTrickCharacters() {
		return trickCharacters;
	}

	public int getIndex() {
		return index;
	}

	public List<TrickListener> getTrickListeners() {
		return trickListeners;
	}

	public int getStatus() {
		return status;
	}

	public char[] getTrickDigitado() {
		return trickDigitado;
	}
	
}
