package italo.pacman.trick;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

public class TrickController {
	
	private static TrickController singleton = null;
	
	public final static char[] TRUQUE_ATRAVESSAR_PAREDES = new char[]{'a','t','r','a','v','e','s','s','a','r',' ','p','a','r','e','d','e','s'};
	public final static char[] TRUQUE_MUDAR_DE_FASE = new char[]{'f','a','s','e','?'};	
	public final static char[] TRUQUE_MUDAR_NUMERO_DE_VIDAS = new char[]{'v','i','d','a','s', Trick.CORINGA, Trick.CORINGA, Trick.CORINGA};
	
	public final static int CHAVE_TRUQUE_ATRAVESSAR_PAREDES = 1;
	public final static int CHAVE_TRUQUE_MUDAR_DE_FASE = 2;	
	public final static int CHAVE_TRUQUE_MUDAR_NUMERO_DE_VIDAS = 1;
	
	private Map<Integer, Trick> gameTricks = new HashMap<Integer, Trick>(); 
		
	private TrickController() {
		gameTricks.put(CHAVE_TRUQUE_ATRAVESSAR_PAREDES, new Trick(TRUQUE_ATRAVESSAR_PAREDES));
		gameTricks.put(CHAVE_TRUQUE_MUDAR_DE_FASE, new Trick(TRUQUE_MUDAR_DE_FASE));
	}
	
	public static TrickController getInstance() {
		if(singleton == null) {
			synchronized(TrickController.class) {
				singleton = new TrickController();
			}
		}
		return singleton;
	}
	
	public Collection<Trick> getGameTricks() {
		return gameTricks.values();
	}
	
	public Trick getGameTrick(int key) {
		return gameTricks.get(key);
	}

	public Trick addGameTrick(int key, Trick value) {
		return gameTricks.put(key, value);
	}
	
	public Trick removeGameTrick(Trick value) {
		return gameTricks.remove(value);
	}
	
}
